local _, ns = ...
local oUF = ns.oUF or oUF
if not oUF then return end

local L = {
  ["Prayer of Mending"] = GetSpellInfo(33076),
  ["Gift of the Naaru"] = GetSpellInfo(59542),
  ["Renew"] = GetSpellInfo(139),
  ["Power Word: Shield"] = GetSpellInfo(17),
  ["Weakened Soul"] = GetSpellInfo(6788),
  ["Prayer of Shadow Protection"] = GetSpellInfo(27683),
  ["Shadow Protection"] = GetSpellInfo(976),
  ["Prayer of Fortitude"] = GetSpellInfo(21562),
  ["Power Word: Fortitude"] = GetSpellInfo(1243),
  ["Divine Spirit"] = GetSpellInfo(48073),
  ["Prayer of Spirit"] = GetSpellInfo(48074),
  ["Fear Ward"] = GetSpellInfo(6346),
  ["Lifebloom"] = GetSpellInfo(33763),
  ["Rejuvenation"] = GetSpellInfo(774),
  ["Regrowth"] = GetSpellInfo(8936),
  ["Wild Growth"] = GetSpellInfo(48438),
  ["Tree of Life"] = GetSpellInfo(33891),
  ["Gift of the Wild"] = GetSpellInfo(48470),
  ["Mark of the Wild"] = GetSpellInfo(48469),
  ["Horn of Winter"] = GetSpellInfo(57623),
  ["Battle Shout"] = GetSpellInfo(47436),
  ["Commanding Shout"] = GetSpellInfo(47440),
  ["Vigilance"] = GetSpellInfo(50720),
  ["Magic Concentration"] = GetSpellInfo(54646),
  ["Beacon of Light"] = GetSpellInfo(53563),
  ["Sacred Shield"] = GetSpellInfo(53601),
  ['Earth Shield'] = GetSpellInfo(49284),
  ['Riptide'] = GetSpellInfo(61301),
  ['Flash of Light'] = GetSpellInfo(66922),
  ['Shield Wall'] = GetSpellInfo(871),
}
local x = "M"

local getTime = function(expirationTime)
	local expire = -1*(GetTime()-expirationTime)
	local timeleft = format("%.0f", expire)
	if expire > 0.5 then
		local spellTimer = "|cffffff00"..timeleft.."|r"
		return spellTimer
	end
end

oUF.Tags['raid:aggro'] = function(u) 
	local s = UnitThreatSituation(u) if s == 2 or s == 3 then return "|cffFF0000"..x.."|r" end end
oUF.TagEvents['raid:aggro'] = "UNIT_THREAT_SITUATION_UPDATE"

--priest
oUF.pomCount = {1,2,3,4,5,6}
oUF.Tags['raid:pom'] = function(u) local c = select(4, UnitAura(u, L["Prayer of Mending"])) if c then return "|cffFFCF7F"..oUF.pomCount[c].."|r" end end
oUF.TagEvents['raid:pom'] = "UNIT_AURA"
oUF.Tags['raid:gotn'] = function(u) if UnitAura(u, L["Gift of the Naaru"]) then return "|cff33FF33"..x.."|r" end end
oUF.TagEvents['raid:gotn'] = "UNIT_AURA"
oUF.Tags['raid:rnw'] = function(u)
  local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L["Renew"])
  if not (fromwho == "player") then return end
  if UnitAura(u, L["Renew"]) then return "|cff33FF33"..x.."|r" end end
oUF.TagEvents['raid:rnw'] = "UNIT_AURA"
-- rnwtime
oUF.Tags['raid:rnwTime'] = function(u)
  local name, _,_,_,_,_, expirationTime, fromwho,_ = UnitAura(u, L["Renew"])
  if (fromwho == "player") then return getTime(expirationTime) end 
end
oUF.TagEvents['raid:rnwTime'] = "UNIT_AURA"
oUF.Tags['raid:pws'] = function(u) if UnitAura(u, L["Power Word: Shield"]) then return "|cff33FF33"..x.."|r" end end
oUF.TagEvents['raid:pws'] = "UNIT_AURA"
oUF.Tags['raid:ws'] = function(u) if UnitDebuff(u, L["Weakened Soul"]) then return "|cffFF9900"..x.."|r" end end
oUF.TagEvents['raid:ws'] = "UNIT_AURA"
oUF.Tags['raid:fw'] = function(u) if UnitAura(u, L["Fear Ward"]) then return "|cff8B4513"..x.."|r" end end
oUF.TagEvents['raid:fw'] = "UNIT_AURA"
oUF.Tags['raid:sp'] = function(u) local c = UnitAura(u, L["Prayer of Shadow Protection"]) or UnitAura(u, "Shadow Protection") if not c then return "|cff9900FF"..x.."|r" end end
oUF.TagEvents['raid:sp'] = "UNIT_AURA"
oUF.Tags['raid:fort'] = function(u) local c = UnitAura(u, L["Prayer of Fortitude"]) or UnitAura(u, L["Power Word: Fortitude"]) if not c then return "|cff00A1DE"..x.."|r" end end
oUF.TagEvents['raid:fort'] = "UNIT_AURA"
oUF.Tags['raid:ds'] = function(u) local c = UnitAura(u, L["Prayer of Spirit"]) or UnitAura(u, L["Divine Spirit"]) if not c then return "|cffffff00"..x.."|r" end end
oUF.TagEvents['raid:ds'] = "UNIT_AURA"
oUF.Tags['raid:wsTime'] = function(u)
  local name, _,_,_,_,_, expirationTime = UnitDebuff(u, L["Weakened Soul"])
  if UnitDebuff(u, L["Weakened Soul"]) then return getTime(expirationTime) end
end
oUF.TagEvents['raid:wsTime'] = "UNIT_AURA"

--druid
oUF.lbCount = { 1, 2, 3 }
oUF.Tags['raid:lb'] = function(u) 
	local name, _,_, c,_,_, expirationTime, fromwho,_ = UnitAura(u, L["Lifebloom"])
	if not (fromwho == "player") then return end
	local spellTimer = GetTime()-expirationTime
	if spellTimer > -2 then
		return "|cffFF0000"..oUF.lbCount[c].."|r"
	elseif spellTimer > -4 then
		return "|cffFF9900"..oUF.lbCount[c].."|r"
	else
		return "|cffA7FD0A"..oUF.lbCount[c].."|r"
	end
end
oUF.TagEvents['raid:lb'] = "UNIT_AURA"
oUF.Tags['raid:rejuv'] = function(u) 
  local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L["Rejuvenation"])
  if not (fromwho == "player") then return end
  if UnitAura(u, L["Rejuvenation"]) then return "|cff00FEBF"..x.."|r" end end
oUF.TagEvents['raid:rejuv'] = "UNIT_AURA"
-- rejuvtime
oUF.Tags['raid:rejuvTime'] = function(u)
  local name, _,_,_,_,_, expirationTime, fromwho,_ = UnitAura(u, L["Rejuvenation"])
  if (fromwho == "player") then return getTime(expirationTime) end 
end
oUF.TagEvents['raid:rejuvTime'] = "UNIT_AURA"
oUF.Tags['raid:regrow'] = function(u) if UnitAura(u, L["Regrowth"]) then return "|cff00FF10"..x.."|r" end end
oUF.TagEvents['raid:regrow'] = "UNIT_AURA"
oUF.Tags['raid:wg'] = function(u) if UnitAura(u, L["Wild Growth"]) then return "|cff33FF33"..x.."|r" end end
oUF.TagEvents['raid:wg'] = "UNIT_AURA"
oUF.Tags['raid:tree'] = function(u) if UnitAura(u, L["Tree of Life"]) then return "|cff33FF33"..x.."|r" end end
oUF.TagEvents['raid:tree'] = "UNIT_AURA"
oUF.Tags['raid:gotw'] = function(u) local c = UnitAura(u, L["Gift of the Wild"]) or UnitAura(u, L["Mark of the Wild"]) if not c then return "|cffFF00FF"..x.."|r" end end
oUF.TagEvents['raid:gotw'] = "UNIT_AURA"

--warrior
oUF.Tags['raid:Bsh'] = function(u) if UnitAura(u, L["Battle Shout"]) then return "|cffff0000"..x.."|r" end end
oUF.TagEvents['raid:Bsh'] = "UNIT_AURA"
oUF.Tags['raid:Csh'] = function(u) if UnitAura(u, L["Commanding Shout"]) then return "|cffffff00"..x.."|r" end end
oUF.TagEvents['raid:Csh'] = "UNIT_AURA"
oUF.Tags['raid:vigil'] = function(u)
  local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L["Vigilance"])
  if not (fromwho == "player") then return end
  if UnitAura(u, L["Vigilance"]) then return "|cffDEB887"..x.."|r" end end
oUF.TagEvents['raid:vigil'] = "UNIT_AURA"
oUF.Tags['raid:SW'] = function(u) if UnitAura(u, L['Shield Wall']) then return "|cff9900FF"..x.."|r" end end
oUF.TagEvents['raid:SW'] = "UNIT_AURA"

--deathknight
oUF.Tags['raid:how'] = function(u) if UnitAura(u, L["Horn of Winter"]) then return "|cffffff10"..x.."|r" end end
oUF.TagEvents['raid:how'] = "UNIT_AURA"

--mage
oUF.Tags['raid:mc'] = function(u) if UnitAura(u, L["Magic Concentration"]) then return "|cffffff00"..x.."|r" end end
oUF.TagEvents['raid:mc'] = "UNIT_AURA"

--paladin
oUF.Tags['raid:sacred'] = function(u) if UnitAura(u, L["Sacred Shield"]) then return "|cffffff10"..x.."|r" end end
oUF.TagEvents['raid:sacred'] = "UNIT_AURA"
oUF.Tags['raid:beacon'] = function(u) if UnitAura(u, L["Beacon of Light"]) then return "|cffffff10"..x.."|r" end end
oUF.TagEvents['raid:beacon'] = "UNIT_AURA"
oUF.Tags['raid:selfsacred'] = function(u)
  local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L["Sacred Shield"])
  if not (fromwho == "player") then return end
  if UnitAura(u, L["Sacred Shield"]) then return "|cffff33ff"..x.."|r" end end
oUF.TagEvents['raid:selfsacred'] = "UNIT_AURA"
oUF.Tags['raid:selfbeacon'] = function(u)
  local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L["Beacon of Light"])
  if not (fromwho == "player") then return end
  if UnitAura(u, L["Beacon of Light"]) then return "|cffff33ff"..x.."|r" end end
oUF.TagEvents['raid:selfbeacon'] = "UNIT_AURA"
oUF.Tags['raid:beaconTime'] = function(u)
  local name, _,_,_,_,_, expirationTime, fromwho,_ = UnitAura(u, L["Beacon of Light"])
  if (fromwho == "player") then return getTime(expirationTime) end 
end
oUF.TagEvents['raid:beaconTime'] = "UNIT_AURA"
oUF.Tags['raid:FoLTime'] = function(u)
  local name, _,_,_,_,_, expirationTime, fromwho,_ = UnitAura(u, L['Flash of Light'])
  if (fromwho == "player") then return getTime(expirationTime) end 
end
oUF.TagEvents['raid:FoLTime'] = "UNIT_AURA"

--shaman
oUF.Tags['raid:rip'] = function(u) 
	local name, _,_,_,_,_,_, fromwho,_ = UnitAura(u, L['Riptide'])
	if not (fromwho == 'player') then return end
	if UnitAura(u, L['Riptide']) then return '|cff00FEBF'..x..'|r' end end
oUF.TagEvents['raid:rip'] = 'UNIT_AURA'

oUF.Tags['raid:ripTime'] = function(u)
	local name, _,_,_,_,_, expirationTime, fromwho,_ = UnitAura(u, L['Riptide'])
	if (fromwho == "player") then return getTime(expirationTime) end 
end
oUF.TagEvents['raid:ripTime'] = 'UNIT_AURA'

oUF.earthCount = {1,2,3,4,5,6,7,8}
oUF.Tags['raid:earth'] = function(u) local c = select(4, UnitAura(u, L['Earth Shield'])) if c then return '|cffFFCF7F'..oUF.earthCount[c]..'|r' end end
oUF.TagEvents['raid:earth'] = 'UNIT_AURA'

oUF.classIndicators={
		["DRUID"] = {
				["TL"] = "[raid:tree]",
				["TR"] = "[raid:gotw]",
				["BL"] = "[raid:regrow][raid:wg]",
				["BR"] = "[raid:lb]",
				["Cen"] = "[raid:rejuvTime]",
		},
		["PRIEST"] = {
				["TL"] = "[raid:pws][raid:ws]",
				["TR"] = "[raid:ds][raid:sp][raid:fort]",
				["BL"] = "[raid:gotn][raid:fw]",
				["BR"] = "[raid:pom]",
				["Cen"] = "[raid:rnwTime]",
		},
		["PALADIN"] = {
				["TL"] = "[raid:selfsacred][raid:sacred]",
				["TR"] = "[raid:selfbeacon][raid:beacon]",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "[raid:beaconTime]",
				
		},
		["WARLOCK"] = {
				["TL"] = "",
				["TR"] = "",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		},
		["WARRIOR"] = {
				["TL"] = "[raid:vigil]",
				["TR"] = "",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		},
		["DEATHKNIGHT"] = {
				["TL"] = "",
				["TR"] = "[raid:how]",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		},
		["SHAMAN"] = {
				["TL"] = "[raid:rip]",
				["TR"] = "",
				["BL"] = "",
				["BR"] = "[raid:earth]",
				["Cen"] = "[raid:ripTime]",
		},
		["HUNTER"] = {
				["TL"] = "",
				["TR"] = "",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		},
		["ROGUE"] = {
				["TL"] = "",
				["TR"] = "",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		},
		["MAGE"] = {
				["TL"] = "",
				["TR"] = "[raid:mc]",
				["BL"] = "",
				["BR"] = "",
				["Cen"] = "",
		}
}
